// 004 u_06_ansistring
// 10 dec 2010

// -- (C) John COLIBRI 2010
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_06_ansistring;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Panel4: TPanel;
    Memo1: TMemo;
    RichEdit1: TRichEdit;
    ListBox1: TListBox;
    Panel5: TPanel;
    Panel6: TPanel;
    Edit1: TEdit;
    Memo2: TMemo;
    ansistring_: TButton;
    generate_cyrillic_: TButton;
    Splitter2: TSplitter;
    convert_cyrillic_: TButton;
    display_hex_: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure ansistring_Click(Sender: TObject);
    procedure generate_cyrillic_Click(Sender: TObject);
    procedure convert_cyrillic_Click(Sender: TObject);
    procedure display_hex_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses Character, u_display_unicode;

{$R *.dfm}

    procedure display(p_text: String);
      begin
        Form1.Memo1.Lines.Add(p_text);
      end; // display

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure do_display(p_string: String);
      var l_index: Integer;
      begin
        with Form1 do
        begin
          ListBox1.Items.Add(p_string);
          RichEdit1.Text:= RichEdit1.Text+ p_string;
          Memo2.Lines.Add(p_string);
          Edit1.Text:= Edit1.Text+ p_string;

          display(f_display_unicode_string(p_string));
          for l_index:= 1 to Length(p_string) do
            display(Format('%2d  $%1x ', [l_index, Ord(p_string[l_index])])+ p_string[l_index]);
        end; // with Form1
      end; // do_display

    procedure do_display_ansi_string(p_ansi_string: AnsiString);
      var l_index: Integer;
      begin
        with Form1 do
        begin
          ListBox1.Items.Add(p_ansi_string);
          RichEdit1.Text:= RichEdit1.Text+ p_ansi_string;
          Memo2.Lines.Add(p_ansi_string);
          Edit1.Text:= Edit1.Text+ p_ansi_string;

          display(f_display_ansi_string(p_ansi_string));
          for l_index:= 1 to Length(p_ansi_string) do
            display(Format('%2d $%1x ', [l_index, Ord(p_ansi_string[l_index])])+ p_ansi_string[l_index]);
        end; // with Form1
      end; // do_display_ansi_string

    var g_ansi_string: AnsiString;

    procedure TForm1.ansistring_Click(Sender: TObject);
      begin
        g_ansi_string:= 'abc ';
        do_display_ansi_string(g_ansi_string);
      end; // ansistring_Click

    type t_cyrillic_string= type Ansistring(1251);

    procedure TForm1.generate_cyrillic_Click(Sender: TObject);
      var l_cyrillic_string: t_cyrillic_string;
          l_index: Integer;
          l_string: String;
      begin
        l_cyrillic_string:= '';
        for l_index := 127+ 65 to 127+ 65+ 7 do
          l_cyrillic_string := l_cyrillic_string + t_cyrillic_string(AnsiChar(l_index));

        ListBox1.Items.Add(l_cyrillic_string);
        RichEdit1.Text:= RichEdit1.Text+ l_cyrillic_string;
        Memo2.Lines.Add(l_cyrillic_string);
        Edit1.Text:= Edit1.Text+ l_cyrillic_string;
        Memo1.Lines.Add(l_cyrillic_string);

        display('');
        display(f_display_ansi_string(AnsiString(l_cyrillic_string)));
        for l_index:= 1 to Length(l_cyrillic_string) do
          display(Format('%2d %1x ', [l_index, Ord(l_cyrillic_string[l_index])])+ l_cyrillic_string[l_index]);
      end; // generate_cyrillic_Click

    procedure TForm1.display_hex_Click(Sender: TObject);
      var l_cyrillic_string: t_cyrillic_string;
          l_index: Integer;
          l_pt_byte_array: t_pt_byte_array;
      begin
        l_cyrillic_string := '';
        for l_index := 127+ 65 to 127+ 65+ 7 do
          l_cyrillic_string:= l_cyrillic_string + t_cyrillic_string(AnsiChar(l_index));
        l_pt_byte_array:= t_pt_byte_array(Integer(l_cyrillic_string)- 12);
        display(f_byte_array_to_hex(l_pt_byte_array^, 12+ 8));
      end; // display_hex_Click

    procedure TForm1.convert_cyrillic_Click(Sender: TObject);
      var l_cyrillic_string: t_cyrillic_string;
          l_index: Integer;
          l_string: String;
      begin
        l_cyrillic_string := '';
        for l_index := 127+ 65 to 127+ 65+ 7 do
          l_cyrillic_string:= l_cyrillic_string + t_cyrillic_string(AnsiChar(l_index));
        l_string:= l_cyrillic_string;
        do_display(l_string);
      end; // convert_cyrillic_Click

    end.

